/* pg_struct contains the necessary parameters to describe a
   pattern generator */

struct pg_struct {

	/* All numbers are in the units of the pattern generator */

    int stage_min;		/* the minimum x/y coordinate */
    int stage_max;		/* the maximum x/y coordinate */
    int aperture_min;		/* minimum aperture width */
    int aperture_max;		/* maximum aperture width */
    int grid_size;		/* the minimum step size, this
				   should be the maximum of the
				   aperture resolution and TWICE
				   the x/y resolution */
    float convert_factor;	/* One pattern generator unit in 
				   Cif-units */
    char *name;			/* the name of the pattern generator */
};

extern struct pg_struct pg_desc;
extern int pg_modified;
